#!/bin/bash

# Data files
TMPJPEG=/tmp/prova.jpg
TMPDJPEG=/tmp/prova.pnm

# Programs
IMGERROR=imgerror
DJPEG=djpegX
CJPEG=cjpeg-mmx

# Froment test.
# 3D, where X=Steps, Y=PSNR, Z=Compress_Quality. All for plane Y.
function froment_steps_cr
{
	QUALITY_STEP=5
	MAX_FROMENT_STEPS=20

	cat <<- EOF
	# Froment test.
	# 3D, where X=Steps, Y=PSNR, Z=Compress_Quality. All for plane Y.
	EOF

	for q in `seq 100 -$QUALITY_STEP 1`
	do
		$CJPEG -quality $q $ORIGINAL > $TMPJPEG

		# Froment 0 steps is a normal decompression
		for s in `seq 0 $MAX_FROMENT_STEPS`
		do
			export JPEG_FROMENT_STEPS=$s
			$DJPEG -restorey froment $TMPJPEG > $TMPDJPEG
			PSNR=`$IMGERROR -ys -p $ORIGINAL -p $TMPDJPEG |
				cut -d \  -f 1`
			echo $s$'\t'$PSNR$'\t'$q
		done
	done
}

# Nosratinia test.
# 3D, where X=Compress_quality Y=PSNR normal, Z=PSNR nosratinia. All for plane Y.
function nosratinia_cr
{
	QUALITY_STEP=5

	cat <<- EOF
	# Nosratinia test.
	# 3D, where X=Compress_quality Y=PSNR normal, Z=PSNR nosratinia. All for plane Y.
	EOF

	for q in `seq 100 -$QUALITY_STEP 1`
	do
		$CJPEG -quality $q $ORIGINAL > $TMPJPEG

		PSNR_NORMAL=`$IMGERROR -ys -p $ORIGINAL -j $TMPJPEG |
			cut -d \  -f 1`

		$DJPEG -restorey nosratinia $TMPJPEG > $TMPDJPEG

		PSNR=`$IMGERROR -ys -p $ORIGINAL -p $TMPDJPEG |
			cut -d \  -f 1`

		echo $q$'\t'$PSNR_NORMAL$'\t'$PSNR
	done
}

if [ $# -ne 2 ]
then
	echo "usage: $0 <graph_type> <original.pnm>" 1>&2
	echo "graphs types:"
	echo " nosratinia_cr"
	echo " froment_steps_cr"
	exit 1
fi

ORIGINAL=$2
	
# Run the graph type
$1
